=begin comment
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

File:
	Motion_Item.pm

Description:
	

Author:
	Jason Sharpee
	jason@sharpee.com

License:
	This free software is licensed under the terms of the GNU public license.

Usage:

	Example initialization:

	
	Constructor Parameters:

	Input states:

	Output states:

Bugs:

Special Thanks to: 
	Bruce Winter - MH
		

@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
=cut

use strict;
use Timer;

package Motion_Item;

@Motion_Item::ISA = ('Base_Item');

my $m_timeout;

sub set
{
	my ($self,$p_state,$p_setby) = @_;


	if ($p_state eq 'on' and $p_setby ne $$self{$m_timeout}) { # Received ON
		$$self{m_timeout} = new Timer() if $$self{m_timeout} eq '';
		$$self{m_timeout}->set(2*60,$self);
	} elsif ( $p_state eq 'off' and $p_setby ne $$self{m_timeout}) { # Motion OFF
		$$self{m_timeout}->stop();
	} elsif ( $p_state eq 'on' and $p_setby eq $$self{m_timeout}) { # Timer expired
		$p_state='off';
	}		
	$self->SUPER::set($p_state,$p_setby);
}

1;

